#ifndef TEST_TREE_H
#define TEST_TREE_H

#include "gentrex.h"

extern char *tree_user[];

void tree_init(void);

#define get_tree_idx(idx, node) \
	(idx = (char **)node - (char **)tree_user, ((idx >= 0) && (idx < sizeof(tree_user)/sizeof(tree_user[0])))) \

#define T(c) (c-'A')

extern int tree_parent_tab[26];

void *tree_child(void *user_ctx, void *node);
void *tree_parent(void *user_ctx, void *node);
void *tree_next(void *user_ctx, void *node);
void tree_print_node(const char *prefix, void *node);
void tree_print_nodecomp(const char *prefix, gentrex_nodecomp_t ndc);

int tag_eq(void *user_ctx, void *node, void *op_cookie, const char *tagname, const char *str);
#endif /* TEST_TREE_H */
